Bug 909510 - Review Request: lrcalc - Littlewood-Richardson Calculator
Review Request: lrcalc - Littlewood-Richardson Calculator
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Mario Blättermann
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-02-08 20:41 EST by Paulo Andrade
Modified: 2013-06-29 14:28 EDT (History)
3 users (show)

See Also:
Fixed In Version: lrcalc-1.1.6-2.beta.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-06-19 22:29:50 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
mario.blaettermann: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)
lrcalc-upstream-mail.txt (2.87 KB, text/plain)
2013-02-08 20:47 EST, Paulo Andrade
no flags Details

  None (edit)
Description Paulo Andrade 2013-02-08 20:41:05 EST
Spec URL: http://pcpa.fedorapeople.org/lrcalc.spec
SRPM URL: http://pcpa.fedorapeople.org/lrcalc-1.1.6-1.beta.fc19.src.rpm
Description: The "Littlewood-Richardson Calculator" is a package of C and Maple programs
for computing Littlewood-Richardson coefficients. The C programs form the
engine of the package, providing fast calculation of single LR coefficients,
products of Schur functions, and skew Schur functions. The Maple code mainly
gives an interface which makes it possible to use the C programs from Maple.
This interface uses the same notation as the SF package of John Stembridge,
to make it easier to use both packages at the same time.
Fedora Account System Username: pcpa
Comment 1 Paulo Andrade 2013-02-08 20:46:15 EST
This package is required by my work in progress
sagemath package, and would correct all the errors
in the pattern

Exception raised:
    Traceback (most recent call last):
.....
        import sage.libs.lrcalc.lrcalc as lrcalc
    ImportError: No module named lrcalc

in the sample full doctest run at
http://pcpa.fedorapeople.org/sagemath/test.log
Comment 2 Paulo Andrade 2013-02-08 20:47:41 EST
Created attachment 695299 [details]
lrcalc-upstream-mail.txt

Upstream response to my request to make available
a tarball with the version used by sagemath.
Comment 3 Mario Blättermann 2013-06-08 09:26:41 EDT
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5483174

the recognizable parts of the rpmlint output:

lrcalc.src: W: file-size-mismatch lrcalc-sage-1.1.6.tar.gz = 300980, http://math.rutgers.edu/~asbuch/lrcalc/lrcalc-sage-1.1.6.tar.gz = 300979
The size of the file in the package does not match the size indicated by
peeking at its URL.  Verify that the file in the package has the intended
contents.

What happened here? In doubt, use the current version from the project website.


lrcalc.i686: W: shared-lib-calls-exit /usr/lib/liblrcalc.so.0.0.0 exit@GLIBC_2.0
This library package calls exit() or _exit(), probably in a non-fork()
context. Doing so from a library is strongly discouraged - when a library
function calls exit(), it prevents the calling program from handling the
error, reporting it to the user, closing files properly, and cleaning up any
state that the program has. It is preferred for the library to return an
actual error code and let the calling program decide how to handle the
situation.

OK, this could lead to problems but it is not up to you to fix. Should be reported upstream.


Besides that, there are some files with outdated FSF addresses. Should be also reported upstream.
Comment 4 Paulo Andrade 2013-06-08 14:09:35 EDT
May thanks for the review.

I mailed upstream about the FSF address, and a ping about
the exit issue, so they can read this review request :-)


Upstream appears to have updated the package without a name
change. Note that it was made available some months after
my initial request and also after mailing upstream
http://trac.sagemath.org/sage_trac/ticket/11563#comment:45

The exit call should never happen at least in Linux for "sane"
arguments to *alloc (the kernel would OOM kill the process
allocating too much memory, but never deny memory), it is called
from the out_of_memory function. Otherwise I could patch it to
let it happily return a NULL pointer and some SIGSEGV handler
catch it, or convert it to an assert (that would call abort,
for "impossible" conditions).

Update:

- Rebuild with updated upstream tarball (#909510#c3).

Spec URL: http://pcpa.fedorapeople.org/lrcalc.spec
SRPM URL: http://pcpa.fedorapeople.org/lrcalc-1.1.6-2.beta.fc20.src.rpm
Comment 5 Mario Blättermann 2013-06-09 04:05:01 EDT
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5484819

$ rpmlint -i -v *
lrcalc.i686: I: checking
lrcalc.i686: W: spelling-error Summary(en_US) Littlewood -> Little wood, Little-wood, Doolittle
The value of this tag appears to be misspelled. Please double-check.

lrcalc.i686: I: checking-url http://math.rutgers.edu/~asbuch/lrcalc (timeout 10 seconds)
lrcalc.i686: W: shared-lib-calls-exit /usr/lib/liblrcalc.so.0.0.0 exit@GLIBC_2.0
This library package calls exit() or _exit(), probably in a non-fork()
context. Doing so from a library is strongly discouraged - when a library
function calls exit(), it prevents the calling program from handling the
error, reporting it to the user, closing files properly, and cleaning up any
state that the program has. It is preferred for the library to return an
actual error code and let the calling program decide how to handle the
situation.

lrcalc.i686: E: incorrect-fsf-address /usr/share/doc/lrcalc-1.1.6/COPYING
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

lrcalc.i686: E: incorrect-fsf-address /usr/share/doc/lrcalc-1.1.6/LICENSE
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

lrcalc.src: I: checking
lrcalc.src: W: spelling-error Summary(en_US) Littlewood -> Little wood, Little-wood, Doolittle
The value of this tag appears to be misspelled. Please double-check.

lrcalc.src: I: checking-url http://math.rutgers.edu/~asbuch/lrcalc (timeout 10 seconds)
lrcalc.src: I: checking-url http://math.rutgers.edu/~asbuch/lrcalc/lrcalc-sage-1.1.6.tar.gz (timeout 10 seconds)
lrcalc.x86_64: I: checking
lrcalc.x86_64: W: spelling-error Summary(en_US) Littlewood -> Little wood, Little-wood, Doolittle
The value of this tag appears to be misspelled. Please double-check.

lrcalc.x86_64: I: checking-url http://math.rutgers.edu/~asbuch/lrcalc (timeout 10 seconds)
lrcalc.x86_64: W: shared-lib-calls-exit /usr/lib64/liblrcalc.so.0.0.0 exit@GLIBC_2.2.5
This library package calls exit() or _exit(), probably in a non-fork()
context. Doing so from a library is strongly discouraged - when a library
function calls exit(), it prevents the calling program from handling the
error, reporting it to the user, closing files properly, and cleaning up any
state that the program has. It is preferred for the library to return an
actual error code and let the calling program decide how to handle the
situation.

lrcalc.x86_64: E: incorrect-fsf-address /usr/share/doc/lrcalc-1.1.6/COPYING
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

lrcalc.x86_64: E: incorrect-fsf-address /usr/share/doc/lrcalc-1.1.6/LICENSE
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

lrcalc-debuginfo.i686: I: checking
lrcalc-debuginfo.i686: I: checking-url http://math.rutgers.edu/~asbuch/lrcalc (timeout 10 seconds)
lrcalc-debuginfo.x86_64: I: checking
lrcalc-debuginfo.x86_64: I: checking-url http://math.rutgers.edu/~asbuch/lrcalc (timeout 10 seconds)
lrcalc-devel.i686: I: checking
lrcalc-devel.i686: I: checking-url http://math.rutgers.edu/~asbuch/lrcalc (timeout 10 seconds)
lrcalc-devel.i686: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

lrcalc-devel.x86_64: I: checking
lrcalc-devel.x86_64: I: checking-url http://math.rutgers.edu/~asbuch/lrcalc (timeout 10 seconds)
lrcalc-devel.x86_64: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

lrcalc.spec: I: checking-url http://math.rutgers.edu/~asbuch/lrcalc/lrcalc-sage-1.1.6.tar.gz (timeout 10 seconds)
7 packages and 1 specfiles checked; 4 errors, 7 warnings.

Besides the already known things, no issues so far.


---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual license.
    GPLv2+
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
    $ sha256sum *
    a6881a9f4991f599bc5f83b455c2a9c86c59e381d78fe663effb2c107504eb97  lrcalc-sage-1.1.6.tar.gz
    a6881a9f4991f599bc5f83b455c2a9c86c59e381d78fe663effb2c107504eb97  lrcalc-sage-1.1.6.tar.gz.orig

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[.] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[+] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[.] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[+] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[.] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[.] MUST: Static libraries must be in a -static package.
[+] MUST: Development files must be in a -devel package.
[+] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
[+] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[.] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[+] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. 
[+] MUST: All filenames in rpm packages must be valid UTF-8.


[.] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[.] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock.
    See Koji build above (which uses Mock anyway).
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[.] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[+] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[.] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[.] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[.] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.


----------------

PACKAGE APPROVED

----------------
Comment 6 Paulo Andrade 2013-06-09 14:50:37 EDT
Many thanks for the review!

New Package SCM Request
=======================
Package Name: lrcalc
Short Description: Littlewood-Richardson Calculator
Owners: pcpa
Branches: f18 f19
InitialCC:
Comment 7 Jon Ciesla 2013-06-10 07:48:17 EDT
Git done (by process-git-requests).
Comment 8 Fedora Update System 2013-06-10 15:05:44 EDT
lrcalc-1.1.6-2.beta.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/lrcalc-1.1.6-2.beta.fc18
Comment 9 Fedora Update System 2013-06-10 15:09:11 EDT
lrcalc-1.1.6-2.beta.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/lrcalc-1.1.6-2.beta.fc19
Comment 10 Fedora Update System 2013-06-11 05:10:01 EDT
lrcalc-1.1.6-2.beta.fc18 has been pushed to the Fedora 18 testing repository.
Comment 11 Fedora Update System 2013-06-19 22:29:50 EDT
lrcalc-1.1.6-2.beta.fc18 has been pushed to the Fedora 18 stable repository.
Comment 12 Fedora Update System 2013-06-29 14:28:08 EDT
lrcalc-1.1.6-2.beta.fc19 has been pushed to the Fedora 19 stable repository.

Note You need to log in before you can comment on or make changes to this bug.